%undefine _auto_set_build_flags
%global tarball_version 6.04-pre1
%global _binaries_in_noarch_packages_terminate_build 0

Summary: Simple kernel loader which boots from a FAT filesystem
Name: syslinux
Version: 6.04
Release: 6%{?dist}
License: GPLv2+
URL: http://syslinux.zytor.com/wiki/index.php/The_Syslinux_Project
Source0: http://www.kernel.org/pub/linux/utils/boot/syslinux/%{name}-%{tarball_version}.tar.xz
Patch0001: 0001-ext4-64bit-feature.patch
Patch0002: 0002-include-sysmacros-h.patch
Patch5000: support-firmware-install-all.patch
Patch5001: multi-definition-of-symbol-errors.patch
Patch5002: replace-strlen-which-will-get-optimized.patch

ExclusiveArch: x86_64
BuildRequires: make, gcc
BuildRequires: nasm >= 0.98.38-1, perl-interpreter, perl-generators, netpbm-progs
BuildRequires: perl(FileHandle), libuuid-devel
Requires: syslinux-nonlinux = %{version}-%{release}
Requires: mtools, libc.so.6()(64bit)


%description
SYSLINUX is a boot loader for the Linux operating system which runs
on an MS-DOS/Windows FAT filesystem. It is intended to simplify
first-time installation of Linux, and for creation of rescue and other
special purpose boot disks.

%package perl
Summary: Syslinux tools written in perl

%description perl
This package provides syslinux tools written in perl.

%package devel
Summary: Headers and libraries for syslinux development.
Provides: %{name}-static = %{version}-%{release}

%description devel
This package provides header files and libraries for syslinux development.

%package extlinux
Summary: The EXTLINUX bootloader, for booting the local system.
Requires: syslinux
Requires: syslinux-extlinux-nonlinux = %{version}-%{release}

%description extlinux
This package provides the EXTLINUX bootloader and all SYSLINUX/PXELINUX
modules in /boot.

%package tftpboot
Summary: SYSLINUX modules in /tftpboot, available for network booting
BuildArch: noarch

%description tftpboot
This package provides the SYSLINUX/PXELINUX modules in the /tftpboot directory
for network booting.

%package extlinux-nonlinux
Summary: The parts of the EXTLINUX bootloader which aren't run from linux.
Requires: syslinux

%description extlinux-nonlinux
This package provides EXTLINUX binaries which run from the firmware.

%package nonlinux
Summary: SYSLINUX modules which aren't run from linux.
Requires: syslinux

%description nonlinux
This package provides SYSLINUX binaries that run from the firmware and 
MEMDISK, which is a tool loads legacy operating systems from media.

%package efi64
Summary: SYSLINUX binaries and modules for 64-bit UEFI systems

%description efi64
This package provides SYSLINUX binaries and modules for 64-bit UEFI systems

%prep
%autosetup -n syslinux-%{tarball_version} -p1

%build
make RPMCFLAGS='%{optflags}' RPMLDFLAGS='%{build_ldflags}' bios clean all
make RPMCFLAGS='%{optflags}' RPMLDFLAGS='%{build_ldflags}' efi64 clean all

%install
rm -rf %{buildroot}

mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}/sbin
mkdir -p %{buildroot}%{_prefix}/lib/syslinux
mkdir -p %{buildroot}%{_includedir}

make bios install-all \
	INSTALLROOT=%{buildroot} SBINDIR=/sbin \
	MANDIR=%{_mandir} LDLINUX=ldlinux.c32
make efi64 install netinstall \
	INSTALLROOT=%{buildroot} SBINDIR=/sbin \
	MANDIR=%{_mandir} LDLINUX=ldlinux.c32

mkdir -p %{buildroot}/etc
mkdir -p %{buildroot}%{_pkgdocdir}/sample
install -m644 sample/sample.* %{buildroot}%{_pkgdocdir}/sample/
( cd %{buildroot}/etc && ln -s ../boot/extlinux/extlinux.conf . )

rm -f %{buildroot}%{_prefix}/lib/libsyslinux*
rm -f %{buildroot}%{_includedir}/syslinux.h

%post extlinux
if [ -f /boot/extlinux/extlinux.conf ]; then
        extlinux --update /boot/extlinux
elif [ -f /boot/extlinux.conf ]; then
        mkdir -p /boot/extlinux && \
        mv /boot/extlinux.conf /boot/extlinux/extlinux.conf && \
        extlinux --update /boot/extlinux
fi

%files
%license COPYING
%doc NEWS README* doc/* sample
%{_bindir}/gethostip
%{_bindir}/isohybrid
%{_bindir}/memdiskfind
%{_bindir}/syslinux
%dir %{_datadir}/syslinux
%dir %{_datadir}/syslinux/dosutil
%{_datadir}/syslinux/dosutil/*
%dir %{_datadir}/syslinux/diag
%{_datadir}/syslinux/diag/*
%{_mandir}/man1/gethostip*
%{_mandir}/man1/syslinux*
%{_mandir}/man1/isohybrid*
%{_mandir}/man1/memdiskfind*

%files perl
%{_bindir}/keytab-lilo
%{_bindir}/lss16toppm
%{_bindir}/md5pass
%{_bindir}/mkdiskimage
%{_bindir}/ppmtolss16
%{_bindir}/pxelinux-options
%{_bindir}/sha1pass
%{_bindir}/syslinux2ansi
%{_bindir}/isohybrid.pl
%{_mandir}/man1/lss16toppm*
%{_mandir}/man1/ppmtolss16*
%{_mandir}/man1/syslinux2ansi*

%files devel
%dir %{_datadir}/syslinux/com32
%{_datadir}/syslinux/com32/*

%files extlinux
/sbin/extlinux
%{_mandir}/man1/extlinux*
%config /etc/extlinux.conf

%files tftpboot
/tftpboot

%files nonlinux
%{_datadir}/syslinux/*.com
%{_datadir}/syslinux/*.c32
%{_datadir}/syslinux/*.bin
%{_datadir}/syslinux/*.0
%{_datadir}/syslinux/memdisk

%files extlinux-nonlinux
/boot/extlinux

%files efi64
%dir %{_datadir}/syslinux/efi64
%{_datadir}/syslinux/efi64

%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 6.04-6
- Rebuilt for OpenCloudOS Stream 23.09

* Tue Aug 22 2023 Shuo Wang <abushwang@tencent.com> - 6.04-5
- Rebuilt for netpbm 11.02.00

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 6.04-4
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 6.04-3
- Rebuilt for OpenCloudOS Stream 23

* Wed Mar 15 2023 cunshunxia <cunshunxia@tencent.com> - 6.04-2
- build subpkgs with x86 instead of noarch.

* Thu Jun 16 2022 cunshunxia <cunshunxia@tencent.com> - 6.04-1
- initial build
